## cataclysm-dda 0.C+git20180520.620a1f9

=== CMakeLists.txt ===
# Main project build script
cmake_minimum_required(VERSION 2.8.12)

PROJECT(CataclysmDDA)

SET(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${CMAKE_SOURCE_DIR}/CMakeModules
)

# Build options
option(LUA          "Lua support (required for some mods)."					"OFF")
option(TILES        "Build graphical tileset version."						"OFF")
option(CURSES       "Build curses version."							"ON" )
option(SOUND        "Support for in-game sounds & music."					"OFF")
option(RELEASE      "Disable debug. Use it for user-ready buils."				"OFF")
option(USE_HOME_DIR "Use user's home directory for save files."					"ON" )
option(LOCALIZE     "Support for language localizations. Also enable UTF support."		"ON" )
option(LANGUAGES    "Compile localization files for specified languages."			""   )
option(DYNAMIC_LINKING "Use dynamic linking. Or use static to remove MinGW dependency instead."	"ON")
option(LUA_BINARY   "Lua binary name or path. You can try to use luajit for extra speed."	"")
option(GIT_BINARY   "Git binary name or path."							"")
OPTION(PREFIX       "Location of Data,GFX, & Lua directories"                                   "")

include(GetGitRevisionDescription)
git_describe(GIT_VERSION)

IF (RELEASE)
MESSAGE("\n * Cataclysm: Dark Days Ahead is a roguelike set in a post-apocalyptic world.")
MESSAGE("   _________            __                   .__                                ")
MESSAGE("   \\_   ___ \\ _____   _/  |_ _____     ____  |  |   ___.__   ______  _____      ")
MESSAGE("   /    \\  \\/ \\__  \\  \\   __\\\\__  \\  _/ ___\\ |  |  <   |  | /  ___/ /     \\     ")
MESSAGE("   \\     \\____ / __ \\_ |  |   / __ \\_\\  \\___ |  |__ \\___  | \\___ \\ |  Y Y  \\    ")
MESSAGE("    \\______  /\(____  / |__|  \(____  / \\___  >|____/ / ____|/____  >|__|_|  /    ")
MESSAGE("           \\/      \\/             \\/      \\/        \\/          \\/       \\/     ")
MESSAGE("                               --= Dark Days Ahead =--")
MESSAGE("\n * http://en.cataclysmdda.com/\n")
ENDIF (RELEASE)

MESSAGE(STATUS "${PROJECT} build environment -- \n")

MESSAGE(STATUS "Build realm is                : ${CMAKE_SYSTEM_NAME} ${CMAKE_HOST_SYSTEM_PROCESSOR}")

if (NOT ${GIT_VERSION} MATCHES GIT-NOTFOUND)
    string(REPLACE "-NOTFOUND" "" GIT_VERSION ${GIT_VERSION})
    FILE(WRITE ${CMAKE_SOURCE_DIR}/src/version.h "\#define VERSION \"${GIT_VERSION}\"\n")
    MESSAGE(STATUS "${PROJECT_NAME} build version is : ${GIT_VERSION}\n")
    ADD_DEFINITIONS(-DGIT_VERSION=${GIT_VERSION})
ELSE (NOT ${GIT_VERSION} MATCHES GIT-NOTFOUND)
    MESSAGE("")
ENDIF(NOT ${GIT_VERSION} MATCHES GIT-NOTFOUND)

#OS Check Placeholders. Will be used for BINDIST
IF (${CMAKE_SYSTEM_NAME} MATCHES Linux)
	SET(_OS_LINUX_ 1)
ENDIF (${CMAKE_SYSTEM_NAME} MATCHES Linux)

IF (${CMAKE_SYSTEM_NAME} MATCHES FreeBSD)
	SET(_OS_FREEBSD_ 1)
ENDIF (${CMAKE_SYSTEM_NAME} MATCHES FreeBSD)

IF(${CMAKE_SYSTEM_NAME} MATCHES Darwin)
	SET(_OS_DARWIN_ 1)
	SET(LOCALIZE OFF)
	MESSAGE(STATUS "Disable internationalization on Darwin as it is not supported")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES Darwin)

include(CheckCXXCompilerFlag)

#FIXME: Add dest build choice: m32 for 32 bit or m64 for 64 bit version
#add_definitions("-m32")
#SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32")
#SET(CMAKE_SHARED_LIBRARY_C_FLAGS "${CMAKE_SHARED_LIBRARY_C_FLAGS} -m32")
#SET(CMAKE_SHARED_LIBRARY_CXX_FLAGS "${CMAKE_SHARED_LIBRARY_CXX_FLAGS} -m32")

IF (NOT DYNAMIC_LINKING)
	SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a;.dll.a")
	SET(BUILD_SHARED_LIBRARIES OFF)
	check_cxx_compiler_flag (-static HAVE_STATIC_FLAG)
	IF(HAVE_STATIC_FLAG)
		SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
	ENDIF(HAVE_STATIC_FLAG)
	# Workaround for cmake link library guesser
	SET(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)       # remove -Wl,-Bdynamic
	SET(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
	SET(CMAKE_SHARED_LIBRARY_C_FLAGS)         # remove -fPIC
	SET(CMAKE_SHARED_LIBRARY_CXX_FLAGS)
	SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS)    # remove -rdynamic
	SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)
ELSE (NOT DYNAMIC_LINKING)
	IF(MINGW AND NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
		# Avoid depending on MinGW runtime DLLs
		SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libgcc -static-libstdc++")
	ENDIF(MINGW AND NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
ENDIF (NOT DYNAMIC_LINKING)

IF(${CMAKE_SYSTEM_NAME} MATCHES Windows)
	SET(_OS_WINDOWS_ 1)
	GET_FILENAME_COMPONENT(MINGW_BIN_DIRECTORY ${CMAKE_CXX_COMPILER} PATH)
	SET(RC_COMPILER_FILENAME "windres.exe")
	FIND_FILE(RC_COMPILER_PATH ${RC_COMPILER_FILENAME})
	IF(RC_COMPILER_PATH)
		MESSAGE(STATUS "Found .rc compiler: ${RC_COMPILER_PATH}")
	ENDIF(RC_COMPILER_PATH)
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES Windows)

#Sysem specific actions
IF (${CMAKE_SYSTEM_NAME} MATCHES Linux OR ${CMAKE_SYSTEM_NAME} MATCHES FreeBSD)
    IF(NOT DATA_PREFIX)
        SET( DATA_PREFIX ${CMAKE_INSTALL_PREFIX}/share/cataclysm-dda)
    ENDIF(NOT DATA_PREFIX)
    IF(NOT LOCALE_DIR)
        SET( LOCALE_DIR ${CMAKE_INSTALL_PREFIX}/share/locale)
    ENDIF(NOT LOCALE_DIR)
    IF(NOT BIN_PREFIX)
        SET( BIN_PREFIX ${CMAKE_INSTALL_PREFIX}/bin)
    ENDIF(NOT BIN_PREFIX)
    IF(NOT DESKTOP_ENTRY_PATH)
        SET( DESKTOP_ENTRY_PATH ${CMAKE_INSTALL_PREFIX}/share/applications)
    ENDIF(NOT DESKTOP_ENTRY_PATH)
    IF(NOT PIXMAPS_ENTRY_PATH)
        SET( PIXMAPS_ENTRY_PATH ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor)
    ENDIF(NOT PIXMAPS_ENTRY_PATH)
    IF(NOT PIXMAPS_UNITY_ENTRY_PATH)
        SET( PIXMAPS_UNITY_ENTRY_PATH ${CMAKE_INSTALL_PREFIX}/share/icons/ubuntu-mono-dark)
    ENDIF(NOT PIXMAPS_UNITY_ENTRY_PATH)
    IF(NOT MANPAGE_ENTRY_PATH)
        SET( MANPAGE_ENTRY_PATH ${CMAKE_INSTALL_PREFIX}/share/man)
    ENDIF(NOT MANPAGE_ENTRY_PATH)
ENDIF (${CMAKE_SYSTEM_NAME} MATCHES Linux OR ${CMAKE_SYSTEM_NAME} MATCHES FreeBSD)

IF (${CMAKE_SYSTEM_NAME} MATCHES Windows)
    IF(NOT DATA_PREFIX)
        SET(DATA_PREFIX ${CMAKE_INSTALL_PREFIX})
    ENDIF(NOT DATA_PREFIX)
    IF(NOT LOCALE_DIR)
        SET(LOCALE_DIR ${CMAKE_INSTALL_PREFIX})
    ENDIF(NOT LOCALE_DIR)
    IF(NOT BIN_PREFIX)
        SET(BIN_PREFIX ${CMAKE_INSTALL_PREFIX})
    ENDIF(NOT BIN_PREFIX)
ENDIF (${CMAKE_SYSTEM_NAME} MATCHES Windows)


MESSAGE(STATUS "${PROJECT_NAME} build options --\n")

# Preset variables
IF (NOT LUA_BINARY)
	SET (LUA_BINARY "lua")
ENDIF (NOT LUA_BINARY)

IF(NOT LANGUAGES)
	SET (LANGUAGES de es_AR es_ES fr it_IT ja ko pt_BR ru zh_CN zh_TW)
ENDIF(NOT LANGUAGES)

IF (GIT_BINARY)
	SET(GIT_EXECUTABLE ${GIT_BINARY})
ELSE (GIT_BINARY)
	FIND_PACKAGE(Git)
	IF (NOT GIT_FOUND)
		MESSAGE(WARNING "Git binary not found. Build version will be set to NULL. Install Git package or use -DGIT_BINARY to set path to git binary.")
	ENDIF (NOT GIT_FOUND)
ENDIF (GIT_BINARY)

IF (PREFIX)
	ADD_DEFINITIONS(-DPREFIX=${PREFIX})
ENDIF (PREFIX)

# Can't compile curses and tiles build's at same time
IF(TILES)
    SET(CURSES OFF)
ENDIF(TILES)

# Set build types and display info
IF(RELEASE)
	MESSAGE(STATUS "CMAKE_INSTALL_PREFIX          : ${CMAKE_INSTALL_PREFIX}")
	MESSAGE(STATUS "BIN_PREFIX                    : ${BIN_PREFIX}")
	MESSAGE(STATUS "DATA_PREFIX                   : ${DATA_PREFIX}")
    IF(LOCALIZE)
        MESSAGE(STATUS "LOCALE_PATH                   : ${LOCALE_DIR}")
    ENDIF(LOCALIZE)
	MESSAGE(STATUS "DESKTOP_ENTRY_PATH            : ${DESKTOP_ENTRY_PATH}")
	MESSAGE(STATUS "PIXMAPS_ENTRY_PATH            : ${PIXMAPS_ENTRY_PATH}")
	MESSAGE(STATUS "PIXMAPS_UNITY_ENTRY_PATH      : ${PIXMAPS_UNITY_ENTRY_PATH}")
	MESSAGE(STATUS "MANPAGE_ENTRY_PATH            : ${MANPAGE_ENTRY_PATH}\n")
	SET(CMAKE_BUILD_TYPE RELEASE)
	ADD_DEFINITIONS(-DRELEASE)
	# FIXME: Removed -Werror for a while. Currently it is broken in upstream.
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Os")
	IF(NOT MSVC)
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra -Wall -std=c++11 -MMD")
	ELSE()
		if(CMAKE_SIZEOF_VOID_P EQUAL 8)
			add_definitions(-D_AMD64_)
		else()
			add_definitions(-D_X86_)
		endif()
	ENDIF()
	IF(MINGW)
		# Workaround for: http://ehc.ac/p/mingw/bugs/2250/
		ADD_DEFINITIONS(-D__NO_INLINE__)
	ENDIF(MINGW)
    # Use PREFIX as storage of data,gfx,lua etc.. Usefull only on *nix OS.
    IF (PREFIX AND NOT WIN32)
	    ADD_DEFINITIONS(-DDATA_DIR_PREFIX)
    ENDIF (PREFIX AND NOT WIN32)
ELSE (RELEASE)
	MESSAGE("\n")
	MESSAGE(STATUS "Build ${PROJECT} in development mode (RELEASE=OFF) --\n")
	MESSAGE(STATUS "Binaries will be located in: " ${CMAKE_SOURCE_DIR})
	SET(CMAKE_BUILD_TYPE DEBUG)
	IF(NOT WIN32)
		# Reduce objects and binary size to avoid 'file too big' error
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GLIBCXX_DEBUG")
	ENDIF(NOT WIN32)
	IF(NOT MSVC)
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra -Wall -std=c++11 -MMD")
	ELSE()
		if(CMAKE_SIZEOF_VOID_P EQUAL 8)
			add_definitions(-D_AMD64_)
		else()
			add_definitions(-D_X86_)
		endif()
	ENDIF()
	SET(CMAKE_VERBOSE_MAKEFILE ON)
	# Since CataclusmDDA does not respect PREFIX for development builds
	# and has funny path handlers, we should create resulting Binaries
	# in the source redectory
	SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY
		${CMAKE_SOURCE_DIR}
		CACHE PATH "Single Directory for all Executables."
	)
	SET(BIN_PREFIX ${CMAKE_SOURCE_DIR})
ENDIF (RELEASE)

	MESSAGE(STATUS "LUA                           : ${LUA}")
IF (LUA)
	MESSAGE(STATUS "LUA_BINARY                    : ${LUA_BINARY}")
ENDIF (LUA)
	MESSAGE(STATUS "GIT_BINARY                    : ${GIT_EXECUTABLE}")
	MESSAGE(STATUS "DYNAMIC_LINKING               : ${DYNAMIC_LINKING}")
	MESSAGE(STATUS "TILES                         : ${TILES}")
	MESSAGE(STATUS "CURSES                        : ${CURSES}")
	MESSAGE(STATUS "SOUND                         : ${SOUND}")
	MESSAGE(STATUS "RELEASE                       : ${RELEASE}")
	MESSAGE(STATUS "LOCALIZE                      : ${LOCALIZE}")
	MESSAGE(STATUS "USE_HOME_DIR                  : ${USE_HOME_DIR}\n")

	MESSAGE(STATUS "LANGUAGES                     : ${LANGUAGES}\n")

	MESSAGE(STATUS "See INSTALL file for details and more info --\n")


# Force out-of-source build
IF(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
	MESSAGE(FATAL_ERROR
		"This project requires an out of source build. Remove the file 'CMakeCache.txt' found in this directory before continuing, create a separate build directory and run 'cmake [options] <srcs>' from there.\nSee INSTALL file for details and more info\n"
	)
ENDIF(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

#SET(THREADS_USE_PTHREADS_WIN32 True)
SET(CMAKE_THREAD_PREFER_PTHREAD True)
FIND_PACKAGE(Threads REQUIRED)

# Check for build types and libraries
IF(TILES)
	# Find SDL, SDL_ttf & SDL_image for graphical install
	MESSAGE(STATUS "Searching for SDL2 library --")
	FIND_PACKAGE(SDL2)
	IF(NOT SDL2_FOUND)
        	MESSAGE(FATAL_ERROR
            		"This project requires SDL2 to be installed to be compiled in graphical mode. Please install the SDL2 development libraries, or try compiling without the -DTILES=1 for a text only compilation.\nSee INSTALL file for details and more info\n"
		)
	ENDIF(NOT SDL2_FOUND)

	IF (NOT DYNAMIC_LINKING)
		# SDL, SDL_Image, SDL_ttf deps are required for static build
		MESSAGE(STATUS "Searching for SDL deps libraries --")
		FIND_PACKAGE(Freetype REQUIRED)
		FIND_PACKAGE(PNG REQUIRED)
		FIND_PACKAGE(JPEG REQUIRED)
		FIND_PACKAGE(ZLIB REQUIRED)
		FIND_PACKAGE(BZip2 REQUIRED)
	ENDIF (NOT DYNAMIC_LINKING)

	MESSAGE(STATUS "Searching for SDL2_image library --")

	MESSAGE(STATUS "Searching for SDL2_TTF library --")
	FIND_PACKAGE(SDL2_ttf)
		IF(NOT SDL2_TTF_FOUND)
		MESSAGE(FATAL_ERROR
			"This project requires SDL2_ttf to be installed to be compiled in graphical mode. Please install the SDL2_ttf development libraries, or try compiling without the -DTILES=1 for a text only compilation.\nSee INSTALL file for details and moreinfo\n"
		)
	ENDIF(NOT SDL2_TTF_FOUND)

	MESSAGE(STATUS "Searching for SDL2_image library --\n")
	FIND_PACKAGE(SDL2_image)
	IF(NOT SDL2_IMAGE_FOUND)
        	MESSAGE(FATAL_ERROR

=== Makefile ===
# vim: set expandtab tabstop=4 softtabstop=2 shiftwidth=2:
# Platforms:
# Linux/Cygwin native
#   (don't need to do anything)
# Linux 64-bit
#   make NATIVE=linux64
# Linux 32-bit
#   make NATIVE=linux32
# Linux cross-compile to Win32
#   make CROSS=i686-pc-mingw32-
#   or make CROSS=i586-mingw32msvc-
#   or whichever prefix your crosscompiler uses
#      as long as its name contains mingw32
# Linux cross-compile to OSX with osxcross
#   make CROSS=x86_64-apple-darwin15-
#        NATIVE=osx
#        CLANG=1
#        OSXCROSS=1
#        LIBSDIR=../libs
#        FRAMEWORKSDIR=../Frameworks
# Win32 (non-Cygwin)
#   Run: make NATIVE=win32
# OS X
#   Run: make NATIVE=osx

# Build types:
# Debug (no optimizations)
#  Default
# ccache (use compilation caches)
#  make CCACHE=1
# Release (turn on optimizations)
#  make RELEASE=1
# Tiles (uses SDL rather than ncurses)
#  make TILES=1
# Sound (requires SDL, so TILES must be enabled)
#  make TILES=1 SOUND=1
# Disable gettext, on some platforms the dependencies are hard to wrangle.
#  make LOCALIZE=0
# Disable backtrace support, not available on all platforms
#  make BACKTRACE=0
# Compile localization files for specified languages
#  make localization LANGUAGES="<lang_id_1>[ lang_id_2][ ...]"
#  (for example: make LANGUAGES="zh_CN zh_TW" for Chinese)
#  make localization LANGUAGES=all
#  (for every .po file in lang/po)
# Change mapsize (reality bubble size)
#  make MAPSIZE=<size>
# Adjust names of build artifacts (for example to allow easily toggling between build types).
#  make BUILD_PREFIX="release-"
# Generate a build artifact prefix from the other build flags.
#  make AUTO_BUILD_PREFIX=1
# Install to system directories.
#  make install
# Enable lua support. Required only for full-fledged mods.
#  make LUA=1
# Use user's XDG base directories for save files and configs.
#  make USE_XDG_DIR=1
# Use user's home directory for save files.
#  make USE_HOME_DIR=1
# Use dynamic linking (requires system libraries).
#  make DYNAMIC_LINKING=1
# Use MSYS2 as the build environment on Windows
#  make MSYS2=1
# Astyle the source files that aren't blacklisted. (maintain current level of styling)
#  make astyle
# Check if source files are styled properly (regression test, astyle_blacklist tracks un-styled files)
#  make astyle-check
# Astyle all source files using the current rules (don't PR this, it's too many changes at once).
#  make astyle-all
# Style the whitelisted json files (maintain the current level of styling).
#  make style-json
# Style all json files using the current rules (don't PR this, it's too many changes at once).
#  make style-all-json

# comment these to toggle them as one sees fit.
# DEBUG is best turned on if you plan to debug in gdb -- please do!
# PROFILE is for use with gprof or a similar program -- don't bother generally
# RELEASE is flags for release builds, this disables some debugging flags and
# enforces build failure when warnings are encountered.
# We want to error on everything to make sure we don't check in code with new warnings.
RELEASE_FLAGS = -Werror
WARNINGS = -Wall -Wextra
# Uncomment below to disable warnings
#WARNINGS = -w
DEBUGSYMS = -g
ifeq ($(shell sh -c 'uname -o 2>/dev/null || echo not'),Cygwin)
  DEBUG =
else
  DEBUG = -D_GLIBCXX_DEBUG
endif
#PROFILE = -pg
#OTHERS = -O3
#DEFINES = -DNDEBUG

# Disable debug. Comment this out to get logging.
#DEFINES = -DENABLE_LOGGING

# Limit debug to level. Comment out all for all levels.
#DEFINES += -DDEBUG_INFO
#DEFINES += -DDEBUG_WARNING
#DEFINES += -DDEBUG_ERROR
#DEFINES += -DDEBUG_PEDANTIC_INFO

# Limit debug to section. Comment out all for all levels.
#DEFINES += -DDEBUG_ENABLE_MAIN
#DEFINES += -DDEBUG_ENABLE_MAP
#DEFINES += -DDEBUG_ENABLE_MAP_GEN
#DEFINES += -DDEBUG_ENABLE_GAME

# Explicitly let 'char' to be 'signed char' to fix #18776
OTHERS += -fsigned-char

VERSION = 0.C

TARGET_NAME = cataclysm
TILES_TARGET_NAME = $(TARGET_NAME)-tiles

TARGET = $(BUILD_PREFIX)$(TARGET_NAME)
TILESTARGET = $(BUILD_PREFIX)$(TILES_TARGET_NAME)
ifdef TILES
APPTARGET = $(TILESTARGET)
else
APPTARGET = $(TARGET)
endif
W32TILESTARGET = $(BUILD_PREFIX)$(TILES_TARGET_NAME).exe
W32TARGET = $(BUILD_PREFIX)$(TARGET_NAME).exe
CHKJSON_BIN = $(BUILD_PREFIX)chkjson
BINDIST_DIR = $(BUILD_PREFIX)bindist
BUILD_DIR = $(CURDIR)
SRC_DIR = src
LUA_DIR = lua
LUASRC_DIR = $(SRC_DIR)/$(LUA_DIR)
# if you have LUAJIT installed, try make LUA_BINARY=luajit for extra speed
LUA_BINARY = lua
LOCALIZE = 1
ASTYLE_BINARY = astyle

# tiles object directories are because gcc gets confused # Appears that the default value of $LD is unsuitable on most systems

# when preprocessor defines change, but the source doesn't
ODIR = $(BUILD_PREFIX)obj
ODIRTILES = $(BUILD_PREFIX)obj/tiles
W32ODIR = $(BUILD_PREFIX)objwin
W32ODIRTILES = $(W32ODIR)/tiles

ifdef AUTO_BUILD_PREFIX
  BUILD_PREFIX = $(if $(RELEASE),release-)$(if $(TILES),tiles-)$(if $(SOUND),sound-)$(if $(LOCALIZE),local-)$(if $(BACKTRACE),back-)$(if $(MAPSIZE),map-$(MAPSIZE)-)$(if $(LUA),lua-)$(if $(USE_XDG_DIR),xdg-)$(if $(USE_HOME_DIR),home-)$(if $(DYNAMIC_LINKING),dynamic-)$(if $(MSYS2),msys2-)
  export BUILD_PREFIX
endif

OS  = $(shell uname -s)

# if $(OS) contains 'BSD'
ifneq ($(findstring BSD,$(OS)),)
  BSD = 1
endif

# This sets CXX and so must be up here
ifdef CLANG
  # Allow setting specific CLANG version
  ifeq ($(CLANG), 1)
    CLANGCMD = clang++
  else
    CLANGCMD = $(CLANG)
  endif
  ifeq ($(NATIVE), osx)
    USE_LIBCXX = 1
  endif
  ifdef USE_LIBCXX
    OTHERS += -stdlib=libc++
    LDFLAGS += -stdlib=libc++
  endif
  ifdef CCACHE
    CXX = CCACHE_CPP2=1 ccache $(CROSS)$(CLANGCMD)
    LD  = CCACHE_CPP2=1 ccache $(CROSS)$(CLANGCMD)
  else
    CXX = $(CROSS)$(CLANGCMD)
    LD  = $(CROSS)$(CLANGCMD)
  endif
else
  # Compiler version & target machine - used later for MXE ICE workaround
  ifdef CROSS
    CXXVERSION := $(shell $(CROSS)$(CXX) --version | grep -i gcc | sed 's/^.* //g')
    CXXMACHINE := $(shell $(CROSS)$(CXX) -dumpmachine)
  endif

  # Expand at reference time to avoid recursive reference
  OS_COMPILER := $(CXX)
  # Appears that the default value of $LD is unsuitable on most systems
  OS_LINKER := $(CXX)
  ifdef CCACHE
    CXX = ccache $(CROSS)$(OS_COMPILER)
    LD  = ccache $(CROSS)$(OS_LINKER)
  else
    CXX = $(CROSS)$(OS_COMPILER)
    LD  = $(CROSS)$(OS_LINKER)
  endif
endif

STRIP = $(CROSS)strip
RC  = $(CROSS)windres
AR  = $(CROSS)ar

# We don't need scientific precision for our math functions, this lets them run much faster.
CXXFLAGS += -ffast-math
LDFLAGS += $(PROFILE)

# enable optimizations. slow to build
ifdef RELEASE
  ifeq ($(NATIVE), osx)
    ifeq ($(shell $(CXX) -E -Os - < /dev/null > /dev/null 2>&1 && echo fos),fos)
      OPTLEVEL = -Os
    else
      OPTLEVEL = -O3
    endif
  else
    # MXE ICE Workaround
    # known bad on 4.9.3 and 4.9.4, if it gets fixed this could include a version test too
    ifeq ($(CXXMACHINE), x86_64-w64-mingw32.static)
      OPTLEVEL = -O3
    else
      OPTLEVEL = -Os
    endif
  endif
  ifdef LTO
    ifdef CLANG
      # LLVM's LTO will complain if the optimization level isn't between O0 and
      # O3 (inclusive)
      OPTLEVEL = -O3
    endif
  endif
  CXXFLAGS += $(OPTLEVEL)

  ifdef LTO
    LDFLAGS += -fuse-ld=gold
    ifdef CLANG
      LTOFLAGS += -flto
    else
      LTOFLAGS += -flto=jobserver -flto-odr-type-merging
    endif
  endif
  CXXFLAGS += $(LTOFLAGS)

  # OTHERS += -mmmx -m3dnow -msse -msse2 -msse3 -mfpmath=sse -mtune=native
  # Strip symbols, generates smaller executable.
  OTHERS += $(RELEASE_FLAGS)
  DEBUG =
  ifndef DEBUG_SYMBOLS
    DEBUGSYMS =
  endif
  DEFINES += -DRELEASE
  # Check for astyle or JSON regressions on release builds.
  CHECKS = astyle-check style-json
endif

ifndef RELEASE
  ifeq ($(shell $(CXX) -E -Og - < /dev/null > /dev/null 2>&1 && echo fog),fog)
    OPTLEVEL = -Og
  else
    OPTLEVEL = -O0
  endif
  CXXFLAGS += $(OPTLEVEL)
endif

ifeq ($(shell sh -c 'uname -o 2>/dev/null || echo not'),Cygwin)
    OTHERS += -std=gnu++11
  else
    OTHERS += -std=c++11
endif

CXXFLAGS += $(WARNINGS) $(DEBUG) $(DEBUGSYMS) $(PROFILE) $(OTHERS) -MMD -MP

BINDIST_EXTRAS += README.md data doc
BINDIST    = $(BUILD_PREFIX)cataclysmdda-$(VERSION).tar.gz
W32BINDIST = $(BUILD_PREFIX)cataclysmdda-$(VERSION).zip
BINDIST_CMD    = tar --transform=s@^$(BINDIST_DIR)@cataclysmdda-$(VERSION)@ -czvf $(BINDIST) $(BINDIST_DIR)
W32BINDIST_CMD = cd $(BINDIST_DIR) && zip -r ../$(W32BINDIST) * && cd $(BUILD_DIR)


# Check if called without a special build target
ifeq ($(NATIVE),)
  ifeq ($(CROSS),)
    ifeq ($(shell sh -c 'uname -o 2>/dev/null || echo not'),Cygwin)
      DEFINES += -DCATA_NO_CPP11_STRING_CONVERSIONS
      TARGETSYSTEM=CYGWIN
    else
      TARGETSYSTEM=LINUX
    endif
  endif
endif

# Linux 64-bit
ifeq ($(NATIVE), linux64)
  CXXFLAGS += -m64
  LDFLAGS += -m64
  TARGETSYSTEM=LINUX
  ifdef GOLD
    CXXFLAGS += -fuse-ld=gold
    LDFLAGS += -fuse-ld=gold
  endif
else
  # Linux 32-bit
  ifeq ($(NATIVE), linux32)
    CXXFLAGS += -m32
    LDFLAGS += -m32
    TARGETSYSTEM=LINUX
    ifdef GOLD
      CXXFLAGS += -fuse-ld=gold
      LDFLAGS += -fuse-ld=gold
    endif
  endif
endif

# OSX
ifeq ($(NATIVE), osx)
  ifdef CLANG
    OSX_MIN = 10.7
  else
    OSX_MIN = 10.5
  endif
  DEFINES += -DMACOSX
  CXXFLAGS += -mmacosx-version-min=$(OSX_MIN)
  LDFLAGS += -mmacosx-version-min=$(OSX_MIN) -framework CoreFoundation
  ifdef FRAMEWORK
    ifeq ($(FRAMEWORKSDIR),)
      FRAMEWORKSDIR := $(strip $(if $(shell [ -d $(HOME)/Library/Frameworks ] && echo 1), \
                             $(if $(shell find $(HOME)/Library/Frameworks -name 'SDL2.*'), \
                               $(HOME)/Library/Frameworks,),))
    endif
    ifeq ($(FRAMEWORKSDIR),)
      FRAMEWORKSDIR := $(strip $(if $(shell find /Library/Frameworks -name 'SDL2.*'), \
                                 /Library/Frameworks,))
    endif
    ifeq ($(FRAMEWORKSDIR),)
      $(error "SDL2 framework not found")
    endif
  endif
  ifeq ($(LOCALIZE), 1)
    LDFLAGS += -lintl
    ifdef OSXCROSS
      LDFLAGS += -L$(LIBSDIR)/gettext/lib
      CXXFLAGS += -I$(LIBSDIR)/gettext/include
    endif
    ifeq ($(MACPORTS), 1)
      ifneq ($(TILES), 1)
        CXXFLAGS += -I$(shell ncursesw6-config --includedir)
        LDFLAGS += -L$(shell ncursesw6-config --libdir)
      endif
    endif
  endif
  TARGETSYSTEM=LINUX
  ifneq ($(OS), Linux)
    BINDIST_CMD = tar -s"@^$(BINDIST_DIR)@cataclysmdda-$(VERSION)@" -czvf $(BINDIST) $(BINDIST_DIR)
  endif
endif

# Win32 (MinGW32 or MinGW-w64(32bit)?)
ifeq ($(NATIVE), win32)
# Any reason not to use -m32 on MinGW32?
  TARGETSYSTEM=WINDOWS
else
  # Win64 (MinGW-w64? 64bit isn't currently working.)
  ifeq ($(NATIVE), win64)
    CXXFLAGS += -m64
    LDFLAGS += -m64
    TARGETSYSTEM=WINDOWS
  endif
endif

# Cygwin
ifeq ($(NATIVE), cygwin)
  TARGETSYSTEM=CYGWIN
endif

# MXE cross-compile to win32
ifneq (,$(findstring mingw32,$(CROSS)))
  DEFINES += -DCROSS_LINUX
  TARGETSYSTEM=WINDOWS
endif

# Global settings for Windows targets
ifeq ($(TARGETSYSTEM),WINDOWS)
  BACKTRACE = 0
  CHKJSON_BIN = chkjson.exe
  TARGET = $(W32TARGET)
  BINDIST = $(W32BINDIST)
  BINDIST_CMD = $(W32BINDIST_CMD)
  ODIR = $(W32ODIR)
  ifdef DYNAMIC_LINKING
    # Windows isn't sold with programming support, these are static to remove MinGW dependency.
    LDFLAGS += -static-libgcc -static-libstdc++
  else
    LDFLAGS += -static
  endif
  ifeq ($(LOCALIZE), 1)
    LDFLAGS += -lintl -liconv
  endif
  W32FLAGS += -Wl,-stack,12000000,-subsystem,windows
  RFLAGS = -J rc -O coff
  ifeq ($(NATIVE), win64)
    RFLAGS += -F pe-x86-64
  endif
endif

ifdef MAPSIZE
    CXXFLAGS += -DMAPSIZE=$(MAPSIZE)
endif

ifeq ($(shell git rev-parse --is-inside-work-tree),true)
  # We have a git repository, use git version
  DEFINES += -DGIT_VERSION
endif

PKG_CONFIG = $(CROSS)pkg-config
SDL2_CONFIG = $(CROSS)sdl2-config

ifdef SOUND
  ifndef TILES
    $(error "SOUND=1 only works with TILES=1")
  endif
  ifeq ($(NATIVE),osx)
    ifdef FRAMEWORK

=== src/CMakeLists.txt ===
# Cataclysm DDA client
cmake_minimum_required(VERSION 2.8.12)

SET(CATACLYSM_DDA_SRCS "")

FILE(GLOB CATACLYSM_DDA_SOURCES
     ${CMAKE_SOURCE_DIR}/src/*.cpp)

FILE(GLOB CATACLYSM_DDA_HEADERS
     ${CMAKE_SOURCE_DIR}/src/*.h)

# Get GIT version strings
ADD_CUSTOM_TARGET(
	get_version
	DEPENDS ${CMAKE_SOURCE_DIR}/src/version.h
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

ADD_CUSTOM_COMMAND (
	OUTPUT ${CMAKE_SOURCE_DIR}/src/version.h
	COMMAND ${CMAKE_COMMAND}
		-D SRC=${CMAKE_SOURCE_DIR}/src/version.h.in
		-D DST=${CMAKE_SOURCE_DIR}/src/version.h
		-D GIT_EXECUTABLE=${GIT_EXECUTABLE}
		-P ${CMAKE_SOURCE_DIR}/src/version.cmake
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

IF(WIN32)
	IF(RC_COMPILER_PATH)
		ADD_CUSTOM_TARGET(
			compile_res
			DEPENDS ${CMAKE_BINARY_DIR}/resource.rc.o
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		)
		ADD_CUSTOM_COMMAND(
			OUTPUT ${CMAKE_BINARY_DIR}/resource.rc.o
			COMMAND	${RC_COMPILER_PATH}
				${CMAKE_SOURCE_DIR}/src/resource.rc
				${CMAKE_BINARY_DIR}/resource.rc.o
			WORKING_DIRECTORY
				${CMAKE_SOURCE_DIR}/src
		)
		SET(CATACLYSM_DDA_SRCS
			${CMAKE_SOURCE_DIR}/src/main.cpp
			${CMAKE_BINARY_DIR}/resource.rc.o
		)
	ENDIF(RC_COMPILER_PATH)
ENDIF(WIN32)

# Build tiles version if requested
IF(TILES)
	IF(WIN32)
		ADD_EXECUTABLE(cataclysm-tiles WIN32
			${CATACLYSM_DDA_SOURCES}
			${CATACLYSM_DDA_HEADERS}
			${CATACLYSM_DDA_SRCS}
		)
	ELSE(WIN32)
		ADD_EXECUTABLE(cataclysm-tiles
			${CATACLYSM_DDA_SOURCES}
			${CATACLYSM_DDA_HEADERS}
		)
	ENDIF(WIN32)

	IF(RC_COMPILER_PATH)
		ADD_DEPENDENCIES(cataclysm-tiles compile_res)
	ENDIF(RC_COMPILER_PATH)

	ADD_DEPENDENCIES(cataclysm-tiles get_version)

	IF (LUA)
		ADD_DEPENDENCIES(cataclysm-tiles lua_bindings)
		target_include_directories(cataclysm-tiles PUBLIC ${LUA_INCLUDE_DIR})
		target_link_libraries(cataclysm-tiles ${LUA_LIBRARIES})
	ENDIF(LUA)

	IF (LOCALIZE)
		target_include_directories(cataclysm-tiles PUBLIC
			${LIBINTL_INCLUDE_DIR}
			${ICONV_INCLUDE_DIR}
		)
		target_link_libraries(cataclysm-tiles
			${LIBINTL_LIBRARIES}
			${ICONV_LIBRARIES}
		)
	ENDIF (LOCALIZE)

	IF(CMAKE_USE_PTHREADS_INIT)
		set_property(TARGET cataclysm-tiles PROPERTY COMPILE_OPTIONS "-pthread")
		set_property(TARGET cataclysm-tiles PROPERTY INTERFACE_COMPILE_OPTIONS "-pthread")
	ENDIF(CMAKE_USE_PTHREADS_INIT)

	IF(CMAKE_THREAD_LIBS_INIT)
		target_link_libraries(cataclysm-tiles ${CMAKE_THREAD_LIBS_INIT})
	ENDIF(CMAKE_THREAD_LIBS_INIT)

	IF (NOT DYNAMIC_LINKING)
		# SDL, SDL_Image, SDL_ttf deps are required for static build
		target_include_directories(cataclysm-tiles PUBLIC
			${FREETYPE_INCLUDE_DIRS}
			${PNG_INCLUDE_DIRS}
			${JPEG_INCLUDE_DIR}
			${ZLIB_INCLUDE_DIRS}
			${BZIP2_INCLUDE_DIR}
		)
		target_link_libraries(cataclysm-tiles
			${FREETYPE_LIBRARIES}
			${PNG_LIBRARIES}
			${JPEG_LIBRARIES}
			${ZLIB_LIBRARIES}
			${BZIP2_LIBRARIES}
		)
	ENDIF (NOT DYNAMIC_LINKING)

	target_include_directories(cataclysm-tiles PUBLIC
		${SDL2_INCLUDE_DIR}
		${SDL2_IMAGE_INCLUDE_DIRS}
		${SDL2_TTF_INCLUDE_DIRS}
	)
	target_link_libraries(cataclysm-tiles
		${SDL2_LIBRARY}
		${SDL2_IMAGE_LIBRARIES}
		${SDL2_TTF_LIBRARIES}
	)

	IF(SOUND)
		set_target_properties(cataclysm-tiles PROPERTIES COMPILE_DEFINITIONS
			"TILES;SDL_SOUND" )

		target_include_directories(cataclysm-tiles PUBLIC ${OGGVORBIS_INCLUDE_DIR})
		target_link_libraries(cataclysm-tiles ${OGG_LIBRARY})
		target_link_libraries(cataclysm-tiles ${VORBIS_LIBRARY})
		target_link_libraries(cataclysm-tiles ${VORBISFILE_LIBRARY})

		target_include_directories(cataclysm-tiles PUBLIC ${SDL2_MIXER_INCLUDE_DIRS})
		target_link_libraries(cataclysm-tiles ${SDL2_MIXER_LIBRARIES})
	ELSE(SOUND)
		# Set additional build props
		set_target_properties(cataclysm-tiles PROPERTIES COMPILE_DEFINITIONS
			"TILES" )
	ENDIF(SOUND)

	IF(WIN32)
		# Global settings for Windows targets (at end)
		target_link_libraries(cataclysm-tiles gdi32.lib)
		target_link_libraries(cataclysm-tiles winmm.lib)
		target_link_libraries(cataclysm-tiles imm32.lib)
		target_link_libraries(cataclysm-tiles ole32.lib)
		target_link_libraries(cataclysm-tiles oleaut32.lib)
		target_link_libraries(cataclysm-tiles version.lib)
	ENDIF(WIN32)

	IF(RELEASE)
		install(TARGETS cataclysm-tiles DESTINATION ${BIN_PREFIX})
	ENDIF(RELEASE)
ENDIF(TILES)

# Build curses version if requested
IF(CURSES)
	IF(WIN32)
		ADD_EXECUTABLE(cataclysm
			${CATACLYSM_DDA_SOURCES}
			${CATACLYSM_DDA_HEADERS}
			${CATACLYSM_DDA_SRCS}
		)
	ELSE(WIN32)
		ADD_EXECUTABLE(cataclysm
			${CATACLYSM_DDA_SOURCES}
			${CATACLYSM_DDA_HEADERS}
		)
	ENDIF(WIN32)

	IF(RC_COMPILER_PATH)
		ADD_DEPENDENCIES(cataclysm compile_res)
	ENDIF(RC_COMPILER_PATH)

	ADD_DEPENDENCIES(cataclysm get_version)

	IF (LUA)
		ADD_DEPENDENCIES(cataclysm lua_bindings)
		target_include_directories(cataclysm PUBLIC ${LUA_INCLUDE_DIR})
		target_link_libraries(cataclysm ${LUA_LIBRARIES})
	ENDIF(LUA)

	IF (LOCALIZE)
		target_include_directories(cataclysm PUBLIC
			${LIBINTL_INCLUDE_DIR}
			${ICONV_INCLUDE_DIR}
		)
		target_link_libraries(cataclysm
			${LIBINTL_LIBRARIES}
			${ICONV_LIBRARIES}
		)
	ENDIF (LOCALIZE)

	target_include_directories(cataclysm PUBLIC ${CURSES_INCLUDE_DIR})
	target_link_libraries(cataclysm ${CURSES_LIBRARIES})

	IF(CMAKE_USE_PTHREADS_INIT)
		set_property(TARGET cataclysm PROPERTY COMPILE_OPTIONS "-pthread")
		set_property(TARGET cataclysm PROPERTY INTERFACE_COMPILE_OPTIONS "-pthread")
	ENDIF(CMAKE_USE_PTHREADS_INIT)

	IF(CMAKE_THREAD_LIBS_INIT)
		target_link_libraries(cataclysm ${CMAKE_THREAD_LIBS_INIT})
	ENDIF(CMAKE_THREAD_LIBS_INIT)

	IF(WIN32)
		# Global settings for Windows targets (at end)
		target_link_libraries(cataclysm gdi32.lib)
		target_link_libraries(cataclysm winmm.lib)
		target_link_libraries(cataclysm imm32.lib)
		target_link_libraries(cataclysm ole32.lib)
		target_link_libraries(cataclysm oleaut32.lib)
		target_link_libraries(cataclysm version.lib)
	ENDIF(WIN32)

	IF(RELEASE)
		install(TARGETS cataclysm DESTINATION ${BIN_PREFIX})
	ENDIF(RELEASE)


ENDIF(CURSES)

IF(MINGW AND NOT RELEASE)
	# Try to Install shared libraries for dev builds
	#
	# Note: It is specific to MSYS2 and uses hardcoded versions so
	# probly it will fail if you run it :)

	# GCC-specific libraries
	find_library(RuntimeLib_GCC_S_DW2_1  "gcc_s_dw2-1")
	find_library(RuntimeLib_STDC_PP_6    "stdc++-6")
	find_library(RuntimeLib_WINPTHREAD_1 "winpthread-1")
	SET(RuntimeLib_GCC_ALL
		${RuntimeLib_GCC_S_DW2_1}
		${RuntimeLib_STDC_PP_6}
		${RuntimeLib_WINPTHREAD_1}
	)
	IF (LUA)
		SET(RuntimeLib_LUA
			${LUA_LIBRARIES}
		)
	ENDIF (LUA)
	IF (LOCALIZE)
		find_library(RuntimeLib_iconv  "libiconv-2")
		find_library(RuntimeLib_intl  "libintl-8")
		SET(RuntimeLib_LOCALIZE
			${RuntimeLib_iconv}
			${RuntimeLib_intl}
		)
	ENDIF (LOCALIZE)
	IF (TILES)
		# SDL2 can have a varoius deps. Here you are the MSYS2 ones...
		find_library(RuntimeLib_SDL2  "SDL2")
		find_library(RuntimeLib_SDL2_IMG  "SDL2_image")
		find_library(RuntimeLib_png  "libpng16-16")
		find_library(RuntimeLib_jpeg  "libjpeg-8")
		find_library(RuntimeLib_jbig  "libjbig-0")
		find_library(RuntimeLib_tiff  "libtiff-5")
		find_library(RuntimeLib_webp  "libwebp-5")
		find_library(RuntimeLib_lzma  "liblzma-5")
		find_library(RuntimeLib_bz2  "libbz2-1")
		find_library(RuntimeLib_zlib  "zlib1")
		find_library(RuntimeLib_hb  "libharfbuzz-0")
		find_library(RuntimeLib_SDL2_TTF  "SDL2_ttf")
		find_library(RuntimeLib_ft  "libfreetype-6")
		find_library(RuntimeLib_glib  "libglib-2.0-0")
		SET(RuntimeLib_SDL
			${RuntimeLib_SDL2}
			${RuntimeLib_SDL2_IMG}
			${RuntimeLib_png}
			${RuntimeLib_jpeg}
			${RuntimeLib_jbig}
			${RuntimeLib_tiff}
			${RuntimeLib_webp}
			${RuntimeLib_lzma}
			${RuntimeLib_bz2}
			${RuntimeLib_zlib}
			${RuntimeLib_hb}
			${RuntimeLib_SDL2_TTF}
			${RuntimeLib_ft}
			${RuntimeLib_glib}
		)
		IF(SOUND)
			find_library(RuntimeLib_SDL_SND  "SDL2_mixer")
			find_library(RuntimeLib_flak  "libFLAC-8")
			find_library(RuntimeLib_ogg  "libogg-0")
			find_library(RuntimeLib_flu  "libfluidsynth-1")
			find_library(RuntimeLib_port  "libportaudio-2")
			find_library(RuntimeLib_snd  "libsndfile-1")
			find_library(RuntimeLib_vorb  "libvorbis-0")
			find_library(RuntimeLib_vorb_enc  "libvorbisenc-2")
			find_library(RuntimeLib_vorb_f  "libvorbisfile-3")
			find_library(RuntimeLib_mod  "libmodplug-1")
			find_library(RuntimeLib_mpeg  "smpeg2")
		SET(RuntimeLib_SDL_SOUND
			${RuntimeLib_SDL_SND}
			${RuntimeLib_flak}
			${RuntimeLib_ogg}
			${RuntimeLib_flu}
			${RuntimeLib_port}
			${RuntimeLib_snd}
			${RuntimeLib_vorb}
			${RuntimeLib_vorb_enc}
			${RuntimeLib_vorb_f}
			${RuntimeLib_mod}
			${RuntimeLib_mpeg}
		)
		ENDIF(SOUND)
	ENDIF (TILES)
	install(FILES ${RuntimeLib_GCC_ALL}
			${RuntimeLib_LOCALIZE}
			${RuntimeLib_LUA}
			${RuntimeLib_SDL}
			${RuntimeLib_SDL_SOUND}
		DESTINATION ${BIN_PREFIX}
	)
ENDIF(MINGW AND NOT RELEASE)

=== tests/Makefile ===
# Make any tests, and possibly run them.
# A selection of variables are exported from the master Makefile.

# As each test will have a main function we need to handle this file by file.
# We're using the fairly typical convention that any file ending in _test.cpp
# is a test executable.
SOURCES = $(wildcard *.cpp)
OBJS = $(SOURCES:%.cpp=$(ODIR)/%.o)

CATA_LIB=../$(BUILD_PREFIX)cataclysm.a

# If you invoke this makefile directly and the parent directory was
# built with BUILD_PREFIX set, you must set it for this invocation as well.
ODIR ?= obj

LDFLAGS += -L.

# Allow use of any header files from cataclysm.
# Catch sections throw unused variable warnings.
# Add no-sign-compare to fix MXE issue when compiling
# Catch also uses "#pragma gcc diagnostic", which is not recognized on some supported compilers.
# Clang and mingw are warning about Catch macros around perfectly normal boolean operations.
CXXFLAGS += -I../src -Wno-unused-variable -Wno-sign-compare -Wno-unknown-pragmas -Wno-parentheses -MMD -MP
CXXFLAGS += -Wall -Wextra

TEST_TARGET = $(BUILD_PREFIX)cata_test

tests: $(TEST_TARGET)

$(BUILD_PREFIX)cata_test: $(ODIR) $(OBJS) $(CATA_LIB)
	+$(CXX) $(W32FLAGS) -o $@ $(DEFINES) $(OBJS) $(CATA_LIB) $(CXXFLAGS) $(LDFLAGS)

# Iterate over all the individual tests.
check: $(TEST_TARGET)
	cd .. && tests/$(TEST_TARGET) -d yes

clean:
	rm -rf *obj
	rm -f *cata_test

$(ODIR):
	mkdir -p $(ODIR)

$(ODIR)/%.o: %.cpp
	$(CXX) $(DEFINES) $(CXXFLAGS) -c $< -o $@

.PHONY: clean check tests

.SECONDARY: $(OBJS)

-include ${OBJS:.o=.d}

=== debian/changelog ===
cataclysm-dda (0.C+git20180520.620a1f9-1) unstable; urgency=low

  * Initial release (Closes: #784764)

 -- Reiner Herrmann <reiner@reiner-h.de>  Wed, 23 May 2018 22:41:28 +0200

=== debian/control ===
Source: cataclysm-dda
Maintainer: Reiner Herrmann <reiner@reiner-h.de>
Section: games
Priority: optional
Build-Depends: debhelper (>= 11),
               libncursesw5-dev,
               librsvg2-bin,
               libsdl2-dev,
               libsdl2-image-dev,
               libsdl2-mixer-dev,
               libsdl2-ttf-dev
Standards-Version: 4.1.4
Homepage: http://www.cataclysmdda.com/
Vcs-Git: https://salsa.debian.org/deki-guest/cataclysm-dda.git
Vcs-Browser: https://salsa.debian.org/deki-guest/cataclysm-dda

Package: cataclysm-dda-data
Architecture: all
Multi-Arch: foreign
Depends: ttf-unifont,
         ${misc:Depends}
Description: post-apocalyptic roguelike game - data files
 Cataclysm: Dark Days Ahead is a roguelike set in a post-apocalyptic world.
 .
 While some have described it as a "zombie game", there's far more to Cataclysm
 than that. Struggle to survive in a harsh, persistent, procedurally generated
 world. Scavenge the remnants of a dead civilization for food, equipment, or,
 if you're lucky, a vehicle with a full tank of gas to get you the hell out of
 Dodge. Fight to defeat or escape from a wide variety of powerful monstrosities,
 from zombies to giant insects to killer robots and things far stranger and
 deadlier, and against the others like yourself, that want what you have...
 .
 This package contains the data files required by any of the frontends.

Package: cataclysm-dda-curses
Architecture: any
Depends: cataclysm-dda-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: cataclysm-dda
Description: post-apocalyptic roguelike game - curses interface
 Cataclysm: Dark Days Ahead is a roguelike set in a post-apocalyptic world.
 .
 While some have described it as a "zombie game", there's far more to Cataclysm
 than that. Struggle to survive in a harsh, persistent, procedurally generated
 world. Scavenge the remnants of a dead civilization for food, equipment, or,
 if you're lucky, a vehicle with a full tank of gas to get you the hell out of
 Dodge. Fight to defeat or escape from a wide variety of powerful monstrosities,
 from zombies to giant insects to killer robots and things far stranger and
 deadlier, and against the others like yourself, that want what you have...
 .
 This package contains the text-only ncurses-based interface.

Package: cataclysm-dda-sdl
Architecture: any
Depends: cataclysm-dda-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: cataclysm-dda
Description: post-apocalyptic roguelike game - SDL interface
 Cataclysm: Dark Days Ahead is a roguelike set in a post-apocalyptic world.
 .
 While some have described it as a "zombie game", there's far more to Cataclysm
 than that. Struggle to survive in a harsh, persistent, procedurally generated
 world. Scavenge the remnants of a dead civilization for food, equipment, or,
 if you're lucky, a vehicle with a full tank of gas to get you the hell out of
 Dodge. Fight to defeat or escape from a wide variety of powerful monstrosities,
 from zombies to giant insects to killer robots and things far stranger and
 deadlier, and against the others like yourself, that want what you have...
 .
 This package contains the graphical SDL2-based interface.

=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

SDL_FLAGS = TILES=1 SOUND=1
CURSES_FLAGS =
COMMON_FLAGS = VERSION=$(DEB_VERSION_UPSTREAM) PREFIX=/usr RELEASE=1 USE_XDG_DIR=1 LANGUAGES=all DEBUG_SYMBOLS=1

# for building with ccache
#COMMON_FLAGS += CCACHE=1

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(COMMON_FLAGS) $(CURSES_FLAGS)
	dh_auto_build -- $(COMMON_FLAGS) $(SDL_FLAGS)
	# generate icons
	for size in 16 32 64 128; do \
		mkdir -p debian/icons/hicolor/$${size}x$${size}/apps; \
		rsvg-convert -o debian/icons/hicolor/$${size}x$${size}/apps/cataclysm-dda.png -w $${size} data/xdg/cataclysm-dda.svg ; \
	done

override_dh_auto_install:
	dh_auto_install -- $(COMMON_FLAGS) $(CURSES_FLAGS)
	dh_auto_install -- $(COMMON_FLAGS) $(SDL_FLAGS)

override_dh_auto_test:
	# we need to pass build flags, otherwise some files are regenerated
	# and the binaries are relinked.
	LC_ALL=C.UTF-8 XDG_CONFIG_HOME=. dh_auto_test -- $(COMMON_FLAGS)

override_dh_install:
	dh_install -Xfont/ -Xcataicon.ico -XLICENSE.txt -Xchangelog.txt

override_dh_clean:
	$(MAKE) clean distclean
	dh_clean

override_dh_installchangelogs:
	dh_installchangelogs data/changelog.txt
